import java.awt.*;
import java.io.*;
import java.awt.image.BufferedImage;
import com.sun.image.codec.jpeg.*;

/**A picture panel that draws a picture when a picture file is input.*/
public class PicturePanel extends Panel
{
    BufferedImage mImage;
    Image mImageBackground;
    int imageWidth, imageHeight;

    /**Constructor.*/    
    public PicturePanel(String filename)
    {	 
        try{
               InputStream in =getClass().getResourceAsStream(filename);
               JPEGImageDecoder decoder = JPEGCodec.createJPEGDecoder(in);
               mImage= decoder.decodeAsBufferedImage();
               in.close(); 
           }catch(Exception e){}  
   
           setSize(mImage.getWidth(), mImage.getHeight());
           imageWidth = mImage.getWidth(); 
           imageHeight = mImage.getHeight();
    }


   /**Draws the picture.*/
    public void paint(Graphics g)
    {
        g.drawImage(mImage, 0, 0, this);
    }
}