import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.*;
import com.sun.image.codec.jpeg.*;

class MappedSphere

{
Pixel[] spPixel = new Pixel[10000];
private int pixCount=0;  
private BufferedImage mImage;

   public MappedSphere(int Radius)
   	{  
           int pixX, pixY,pixZ, pixY_Limit, pixSize=1;


	   for (pixZ=-Radius; pixZ<Radius; pixZ+=pixSize)
		{
		    pixY_Limit = (int)Math.sqrt(Radius*Radius - pixZ*pixZ);    		    	    
		    for(pixY=-pixY_Limit; pixY<pixY_Limit; pixY+=pixSize)
			{  
			                                                  					   pixX=(int)(Math.sqrt(Radius*Radius- pixZ*pixZ- pixY*pixY));

			   spPixel[pixCount] = new Pixel(pixX, pixY, pixZ,pixSize);
			   
                           
                           pixCount++;	
			}
			
		}           
 	   
	}



   public void createMap(String filename)
	{
        	
           try{

           InputStream in =getClass().getResourceAsStream(filename);
           JPEGImageDecoder decoder = JPEGCodec.createJPEGDecoder(in);
           mImage= decoder.decodeAsBufferedImage();
           in.close(); 

           }catch(Exception e){}  
	}



   public void mappingXZrotation(double mappingAngle, double mapMidPoint) // 0<=midPoint<=1
	{
            double cosMappingAngle=Math.cos(mappingAngle);
	    double sinMappingAngle=Math.sin(mappingAngle);
            double sitaZ,phiXY;
            float pixelUnitX, pixelUnitY, pixelUnitZ;
            double mapUnitX, mapUnitY, mapUnitZ, XYradius; 
            int mapWidth = mImage.getWidth();
            int mapHeight = mImage.getHeight();
            int mapX,mapY;
            int colorInteger, red, green, blue;
            Color color;
            
            
	    for(int i=0;i<pixCount;i++)
		{
		   pixelUnitX=spPixel[i].getUnitX();                         
		   pixelUnitY=spPixel[i].getUnitY();                         
		   pixelUnitZ=spPixel[i].getUnitZ();
                   
                   mapUnitX = cosMappingAngle*pixelUnitX - sinMappingAngle* pixelUnitZ;
                   mapUnitY = (double)pixelUnitY;
		   mapUnitZ = sinMappingAngle*pixelUnitX + cosMappingAngle* pixelUnitZ;
                   
                   sitaZ = Math.acos(mapUnitZ);
                   XYradius = Math.sqrt(1-mapUnitZ*mapUnitZ);
                   
                   if(mapUnitX>=0.0d) {phiXY = Math.asin(mapUnitY/XYradius);}
                   else  {phiXY =3.141592654 -Math.asin(mapUnitY/XYradius);}
                   mapY = (int)((sitaZ/3.141592654)*(mapHeight-1));                   

                   phiXY=phiXY/6.283185307+mapMidPoint;
                   if(phiXY>=1){phiXY--;}
                   if(phiXY<0){phiXY++;}
                   mapX = (int)(phiXY*(mapWidth-1));       
                   
                   
                     
                  
	    
                   colorInteger = 16777216 + mImage.getRGB(mapX,mapY);
                   red = (int)(colorInteger/65536);
                   green = (int)((colorInteger-red*65536)/256);
                   blue = colorInteger-65536*red-256*green;      
                   color = new Color(red, green, blue);
                   spPixel[i].setPixelColor(color);                   
                                            
		}
	}


public void mappingYZrotation(double mappingAngle, double mapMidPoint) // 0<=midPoint<=1
	{
            double cosMappingAngle=Math.cos(mappingAngle);
	    double sinMappingAngle=Math.sin(mappingAngle);
            double sitaZ,phiXY;
            float pixelUnitX, pixelUnitY, pixelUnitZ;
            double mapUnitX, mapUnitY, mapUnitZ, XYradius; 
            int mapWidth = mImage.getWidth();
            int mapHeight = mImage.getHeight();
            int mapX,mapY;
            int colorInteger, red, green, blue;
            Color color;
            
            
	    for(int i=0;i<pixCount;i++)
		{
		   pixelUnitX=spPixel[i].getUnitX();                         
		   pixelUnitY=spPixel[i].getUnitY();                         
		   pixelUnitZ=spPixel[i].getUnitZ();
                   
                   mapUnitX = (double)pixelUnitX;
                   mapUnitY = cosMappingAngle*pixelUnitY+sinMappingAngle*pixelUnitZ;
		   mapUnitZ = -sinMappingAngle*pixelUnitY+cosMappingAngle*pixelUnitZ;
                   
                   sitaZ = Math.acos(mapUnitZ);  
                   mapY = (int)((sitaZ/3.141592654)*(mapHeight-1));                   

                   XYradius = Math.sqrt(1-mapUnitZ*mapUnitZ);
                   phiXY = Math.asin(mapUnitY/XYradius);
                  
                   mapY = (int)((sitaZ/3.141592654)*(mapHeight-1));
                   if (mapY==mapHeight){mapY--;} 
                   

                   phiXY=phiXY/6.283185307+mapMidPoint;
                   if(phiXY>=1){phiXY--;}
                   if(phiXY<0){phiXY++;}
                   mapX = (int)(phiXY*mapWidth);       
                  
                     
                  
	    
                   colorInteger = 16777216 + mImage.getRGB(mapX,mapY);
                   red = (int)(colorInteger/65536);
                   green = (int)((colorInteger-red*65536)/256);
                   blue = colorInteger-65536*red-256*green;      
                   color = new Color(red, green, blue);
                   spPixel[i].setPixelColor(color);                   
                                            
		}
	}



   public void mapping3Drotation(double mappingAngle, double mapMidPoint) // 0<=midPoint<=1
	{
            double cosMappingAngle=Math.cos(mappingAngle);
	    double sinMappingAngle=Math.sin(mappingAngle);
            double sitaZ,phiXY;
            float pixelUnitX, pixelUnitY, pixelUnitZ;
            double mapUnitX, mapUnitY, mapUnitZ, XYradius; 
            int mapWidth = mImage.getWidth();
            int mapHeight = mImage.getHeight();
            int mapX,mapY;
            int colorInteger, red, green, blue;
            Color color;
          
       
         
	    for(int i=0;i<pixCount;i++)
		{
		   pixelUnitX=spPixel[i].getUnitX();                         
		   pixelUnitY=spPixel[i].getUnitY();                         
		   pixelUnitZ=spPixel[i].getUnitZ();
                   
		   //0.917060074 =cos23.5                   
                   //0.398749068 =sin23.5
   

                   mapUnitX = cosMappingAngle*pixelUnitX - sinMappingAngle* pixelUnitZ;
                  
		   mapUnitY = 0.917060074*pixelUnitY-
	           0.398749068*(sinMappingAngle*pixelUnitX + cosMappingAngle* pixelUnitZ);
		   
                   mapUnitZ = 0.398749068*pixelUnitY+
                   0.917060074*(sinMappingAngle*pixelUnitX + cosMappingAngle* pixelUnitZ);
                   
                   sitaZ = Math.acos(mapUnitZ);
                      
                   XYradius = Math.sqrt(1-mapUnitZ*mapUnitZ);
                   if(mapUnitX>=0.0d) {phiXY = Math.asin(mapUnitY/XYradius);}
                   else  {phiXY =3.141592654 -Math.asin(mapUnitY/XYradius);}
                   mapY = (int)((sitaZ/3.141592654)*(mapHeight-1));                   

                   phiXY=phiXY/6.283185307+mapMidPoint;
                   if(phiXY>=1){phiXY--;}
                   if(phiXY<0){phiXY++;}
                   mapX = (int)(phiXY*(mapWidth-1));       
                   
                   
                     
                  
	    
                   colorInteger = 16777216 + mImage.getRGB(mapX,mapY);
                   red = (int)(colorInteger/65536);
                   green = (int)((colorInteger-red*65536)/256);
                   blue = colorInteger-65536*red-256*green;      
                   color = new Color(red, green, blue);
                   spPixel[i].setPixelColor(color);                   
                                            
		}
	    
	}


   public void lumination (Pixel lumPoint)
	{
	   int i;
           float lumDotProduct;
           for (i=0; i<pixCount; i++)
                {
		    lumDotProduct= Pixel.unitDotProduct(lumPoint,spPixel[i]);
                 
                    if(lumDotProduct>=0.01)
                    	{
                            spPixel[i].setPixelBrightness(0.8f*lumDotProduct+0.2f);
		          //spPixel[i].setPixelBrightness(1.6f);
			}
		    else{
 			   spPixel[i].setPixelBrightness(0.2f);
			}
		}   

	}  
   

   public int getPixelCount()   { return pixCount; }


   public int getImageWidth()   { return mImage.getWidth();   }

   public int getImageHeight()   { return mImage.getHeight();  }
   
}