import java.awt.*;

/**This class creates 12 spherical zodiac signs by calling MappedReflectiveSphere.*/
public class Horoscope
{
    private static final double earthAXISCOS=0.917060074;//cos(23.5)
    private static final double earthAXISSIN=0.398749068; //sin(23.5)
    public Pixel[] horoPosition = new Pixel[12];
    public Pixel[] oriHoroPosition = new Pixel[12];
    private static int obsDistanceToEarth;
    private static int celestialRadius=180;
    private static int screenDistance=1000;
    public int noOfHoroscope=12;
    public int noPixHoroSphere;
    private Pixel lum = new Pixel(100,10, -20);
    private Color sourceColor = new Color(230,230,255);

    public MappedReflectiveSphere[] horoSphere = new MappedReflectiveSphere[12];

    public String[] horoscope= {"capricornus.jpg", "aquarius.jpg", "pisces.jpg",
                                "aries.jpg", "taurus.jpg", "gemini.jpg", 
                                "cancer.jpg", "leo.jpg", "virgo.jpg","libra.jpg",
                                "scorpius.jpg", "sagittarius.jpg"};
    /*Constructor.*/
    public Horoscope(int obs_Distance, int sphereRadius)
    {  
        int i;
        double angleStep, x, y, z;
        float brightness;

        angleStep = 6.283185308/12; 
        obsDistanceToEarth=obs_Distance;

        for(i=0;i<noOfHoroscope;i++)
        {
            x = -celestialRadius*Math.sin(angleStep*i+3.403392041);
            y = celestialRadius*earthAXISCOS*Math.cos(angleStep*i+3.403392041);
            z = celestialRadius*earthAXISSIN*Math.cos(angleStep*i+3.403392041);

            oriHoroPosition[i]=new Pixel((int)x,(int)y,(int)z);

            horoSphere[i] = new MappedReflectiveSphere(sphereRadius, 0.18, 1);
            horoSphere[i].createMap(horoscope[i]);
            horoSphere[i].mappingXZrotation(0.0d,0.5);
            horoSphere[i].lumination(lum , sourceColor);
        }

        noPixHoroSphere = horoSphere[0].getPixelCount();
    }
  
    /**Changes the perspective of the zodiac signs.*/
    public void rotateHoro(double angle)					  
    {
        double x, y, z, cosRotation, sinRotation;

        cosRotation = Math.cos(angle);
        sinRotation = Math.sin(angle);

        for(int i=0;i<noOfHoroscope;i++)
        {
           x = cosRotation*oriHoroPosition[i].getX()+sinRotation*oriHoroPosition[i].getY();
           y =-sinRotation*oriHoroPosition[i].getX()+cosRotation*oriHoroPosition[i].getY();	
           z = oriHoroPosition[i].getZ();

           y = y*screenDistance/(obsDistanceToEarth-x);
           z = z*screenDistance/(obsDistanceToEarth-x);

           horoPosition[i] = new Pixel((int)x, (int)y, (int)z);                   
        }
    }
}