import java.awt.*;

/**This class calculates the boundary of the 12 zodiac signs.*/
public class ZodiacMarker
{
    private static final double earthAXISCOS=0.917060074;//cos(23.5)
    private static final double earthAXISSIN=0.398749068; //sin(23.5)
    public Pixel[] marker = new Pixel[12];
    public Pixel[] originalMarker = new Pixel[12];
    private static int obsDistanceToEarth;
    private static int celestialRadius=180;
    private static int screenDistance=1000;
    public int noOfPixel=12;

    /**Costructor.*/
    public ZodiacMarker(int obs_Distance)
    {  
        int i;
        double angleStep, x, y, z;
        float brightness;

        angleStep = 6.283185308/12; 
        obsDistanceToEarth=obs_Distance;

        for(i=0;i<noOfPixel;i++)
        {
            x = celestialRadius*Math.sin(angleStep*i);
            y = celestialRadius*earthAXISCOS*Math.cos(angleStep*i);
            z = celestialRadius*earthAXISSIN*Math.cos(angleStep*i);
                  
            brightness = (float)(0.5+0.25*(1+x/celestialRadius));
            originalMarker[i]=new Pixel((int)x,(int)y,(int)z);  
        }   
    }

    /**Calculates the boundary of the zodiac signs for a particular perspective.*/
    public void rotateZodiacMarker(double angle)					  
    {
        double x, y, z, cosRotation, sinRotation;
        cosRotation = Math.cos(angle);
        sinRotation = Math.sin(angle);

        for(int i=0;i<noOfPixel;i++)
        {
            x = cosRotation*originalMarker[i].getX()+sinRotation*originalMarker[i].getY();
            y =-sinRotation*originalMarker[i].getX()+cosRotation*originalMarker[i].getY();	
            z = originalMarker[i].getZ();

            y = y*screenDistance/(obsDistanceToEarth-x);
            z = z*screenDistance/(obsDistanceToEarth-x);

            marker[i] = new Pixel((int)x, (int)y, (int)z);                   
        }
    }
}