/**This class defines a machine that calculates the motion of the earth around the sun.*/
public class EarthMotionCalculationMachine
{  
   private static final double earthAXISCOS=0.91706;//cos(23.5)
   private static final double earthAXISSIN=0.398749; //sin(23.5)
   private static final int celestialRadius=145; 
   private static final double screenDistance = 1000;
   private int obs_Dis; 
   public double obs_AngleSin, obs_AngleCos; 
   private double sunAngular, earthAngular;
   private double x,y,z,sunRadius;
   
   /**Constructor.*/
   public EarthMotionCalculationMachine(double obs_Angle, int obs_Distance, double sun_AngSpeed, double earth_AngSpeed)
   {  
       sunAngular=sun_AngSpeed;
       earthAngular=earth_AngSpeed;
       obs_Dis=obs_Distance;
       obs_AngleSin=Math.sin(obs_Angle);
       obs_AngleCos=Math.cos(obs_Angle);
   }

   /**Calculates the position of the earth w.r.t the sun at a particular time.*/
   public void transform(double time)
   {
       double sinSun, cosSun, sinEarth, cosEarth;

       sinSun = Math.sin(sunAngular*time);
       cosSun = Math.cos(sunAngular*time);

       x= obs_AngleCos*cosSun;
       y= sinSun;
       z= -obs_AngleSin*cosSun;
   }

   /**Gets the X-position of the earth.*/
   public double getEarthX()   {return x;}

   /**Gets the Y-position of the earth.*/
   public double getEarthY()   {return y;}

   /**Gets the Z-position of the earth.*/
   public double getEarthZ()   {return z;}

   /**Gets the height of the earth orbit on the screen.*/
   public double getcelestXYelipHeight()
   {
       return Math.abs((screenDistance/obs_Dis)*celestialRadius*obs_AngleSin);
   }	
}

