/**This class defines the orbit of the earth around the sun.*/
public class EarthTrackGenerator
{
   public Pixel[] trPixel=new Pixel[111];
   private static int obsDistanceToSun;
   private static int celestialRadius=145;
   private static int screenDistance=1000;
   public int noOfPixel;
   public double sin_ObsAngle, cos_ObsAngle;

   /**Constructor.*/
   public EarthTrackGenerator(int noPix, double obs_Angle, int obs_Distance)
   {
       noOfPixel=noPix;
       obsDistanceToSun=obs_Distance;
       sin_ObsAngle = Math.sin(obs_Angle);
       cos_ObsAngle = Math.cos(obs_Angle);
   }

   /**Generates an array of points that represents the orbit of the earth around the sun.*/
   public void earthTrack()					  
   {
       int i;
       double x, y, z, angleStep;    

       angleStep = 6.283185308/(noOfPixel-1);  

       for(i=0;i<noOfPixel;i++)
       {              
           x = cos_ObsAngle*Math.sin(angleStep*i+1.570796327);
           y = Math.cos(angleStep*i+1.570796327);
           z = -sin_ObsAngle*Math.sin(angleStep*i+1.570796327);

           x= celestialRadius*x;
           y= (screenDistance/(obsDistanceToSun-x))*y*celestialRadius;
           z= (screenDistance/(obsDistanceToSun-x))*z*celestialRadius;
        
           trPixel[i]=new Pixel((int)x,(int)y,(int)z);	   
       }
   }
}