/**This class defines a 3D-oval plane.*/
public class OvalPlane
{
   private Pixel planeDirection;
   private Pixel rotatedPlaneDirection;
   private int planeRadius;  
   private int planeWidth, planeHeight;
  
   /**Constructor.*/
   public OvalPlane(int planeRad, Pixel planeDir)
   {
       planeRadius = planeRad;
       planeDirection = planeDir;
   }

   /**Rotates this plane.*/
   public void rotatePlane(double angle)
   {
       double cosAngle, sinAngle;
       int x, y, z;

       cosAngle = Math.cos(angle);
       sinAngle = Math.sin(angle);

       x = (int)(cosAngle*planeDirection.getX()+sinAngle*planeDirection.getZ());
       y = planeDirection.getY();
       z = (int)(-sinAngle*planeDirection.getX()+cosAngle*planeDirection.getZ());           
          
       rotatedPlaneDirection=new Pixel(x,y,z);

       planeWidth =  planeRadius*2;
       planeHeight = (int)(2*planeRadius*Math.sin(angle));
   }

   /**Gets the 3D-direction of the rotated Plane.*/
   public Pixel getRotatedPlaneDirection() {return rotatedPlaneDirection;}

   /**Returns the width of the plane.*/
   public int getplaneWidth() {return planeWidth;}

   /**Returns the height of the plane.*/
   public int getplaneHeight() {return planeHeight;}
}